/*globals define*/

define([
    'testsuite/qunit',
    'testsuite/qunit-fixture!ep/fn/shownexton-test',
    'jquery',
    'ep/fn/shownexton',

    '$ready!'
], function (QUnit, fixture, $, ep) {

    QUnit.module("ep/fn/shownexton", {
        setup: fixture.init,
        teardown: fixture.destroy
    });

    QUnit.test("ep/fn/shownexton", function () {
        // Check function.

        QUnit.equal(
            $.isFunction(ep.fn.showNextOn),
            true,
            '$.isFunction(' + 'ep.fn.showNextOn' + '):'
        );

        // Init Test1.
        $('#qunit-fixture li.showNextOn').first().showNextOn(
            'click',
            'button#clickThisToShowNext2',
            2,
            false
        );

        // Init Test2.
        $('#qunit-fixture li.showNextOn:eq(1)').showNextOn(
            'click',
            'button#clickThisToShowNext1',
            1,
            true
        );

        // Check "bootstrap".
        QUnit.equal(
            $('#qunit-fixture li:visible').length,
            2,
            'Two *li* items are *:visible*'
        );

        $('#qunit-fixture li.showNextOn').each(function (i) {
            QUnit.equal(
                $._data(this, 'events') && $._data(this, 'events').click && ($._data(this, 'events').click.length === 1),
                true,
                '*click* handler assigned to ' + i + 'th *li.showNextOn* element'
            );
        });

        // Click *clickThisToShowNext2* button.
        $('#qunit-fixture button#clickThisToShowNext2').trigger('click');

        QUnit.equal(
            $('#qunit-fixture li span.someStuff:visible').length === 2,
            true,
            'Clicking the respective button made the next two list items visible'
        );

        QUnit.equal(
            $('#qunit-fixture li.showNextOn').first().is(':visible'),
            true,
            'The button clicked is still visible'
        );

        $('#qunit-fixture li.showNextOn').each(function (i) {
            QUnit.equal(
                $._data(this, 'events') && $._data(this, 'events').click && ($._data(this, 'events').click.length === 1),
                i === 1 ? true : undefined,
                '*click* handler assigned to ' + i + 'th *li.showNextOn* element'
            );
        });

        // Click *clickThisToShowNext2* button.
        $('#qunit-fixture button#clickThisToShowNext1').trigger('click');

        QUnit.equal(
            $('#qunit-fixture li span.someMoreStuff:visible').length === 1,
            true,
            'Clicking the respective button made the next list item visible'
        );

        QUnit.equal(
            $('#qunit-fixture li.showNextOn:visible').length === 1,
            true,
            'Clicking the respective button made the button invisible'
        );
    });
});