/*global define*/
/*jslint vars:true, browser:true*/
define([
    'testsuite/qunit',
    'testsuite/qunit-fixture!de_epages/ebay/ui/ebaycategorycontroller-test.html',
    'jquery',
    'de_epages/ebay/ui/ebaycategorycontroller',
    'ep/core',

    '$ready!'
], function (QUnit, fixture, $, de_epages, ep) {
    'use strict';

    QUnit.module("de_epages/ebay/ui/ebaycategorycontroller", {
        setup: fixture.init
        // ,
        // teardown: fixture.destroy
    });

    var controllerString = '{"25":{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":11233,"IsExpired":"","ParentCategoryID":null,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":1,"EbayCategoryID":25,"Path":[{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":11233,"IsExpired":"","ParentCategoryID":null,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":1,"EbayCategoryID":25,"AttributeSetID":null,"Name":"Musik"}],"AttributeSetID":null,"Name":"Musik","updated":true,"children":[12052,12257,12053,12222,12061,12239,12240]},"12052":{"IsLeaf":1,"IsVirtual":"","ExternalCategoryId":176984,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12052,"Path":[{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":11233,"IsExpired":"","ParentCategoryID":null,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":1,"EbayCategoryID":25,"AttributeSetID":null,"Name":"Musik"},{"IsLeaf":1,"IsVirtual":"","ExternalCategoryId":176984,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12052,"AttributeSetID":null,"Name":"CDs"}],"AttributeSetID":null,"Name":"CDs"},"12053":{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":176983,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12053,"AttributeSetID":null,"Name":"Musikkassetten"},"12061":{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":176985,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12061,"AttributeSetID":null,"Name":"Vinyl"},"12222":{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":160539,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12222,"AttributeSetID":null,"Name":"Schellack"},"12239":{"IsLeaf":1,"IsVirtual":"","ExternalCategoryId":618,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12239,"AttributeSetID":null,"Name":"Weitere Formate"},"12240":{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":52473,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12240,"AttributeSetID":null,"Name":"Zubehör & Aufbewahrung"},"12257":{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":157499,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12257,"AttributeSetID":null,"Name":"Fanartikel & Merchandise"}}',
        controller = JSON.parse(controllerString),

        responseString = '{"CurrentCategory":{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":52473,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12240,"Path":[{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":11233,"IsExpired":"","ParentCategoryID":null,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":1,"EbayCategoryID":25,"AttributeSetID":null,"Name":"Musik"},{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":52473,"IsExpired":"","ParentCategoryID":25,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":2,"EbayCategoryID":12240,"AttributeSetID":null,"Name":"Zubehör & Aufbewahrung"}],"AttributeSetID":null,"Name":"Zubehör & Aufbewahrung"},"CategoryList":[{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":81377,"IsExpired":"","ParentCategoryID":12240,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":3,"EbayCategoryID":12241,"AttributeSetID":null,"Name":"CD-Aufbewahrung"},{"IsLeaf":1,"IsVirtual":"","ExternalCategoryId":139068,"IsExpired":"","ParentCategoryID":12240,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":3,"EbayCategoryID":12246,"AttributeSetID":null,"Name":"Schellack-Zubehör"},{"IsLeaf":1,"IsVirtual":"","ExternalCategoryId":27579,"IsExpired":"","ParentCategoryID":12240,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":3,"EbayCategoryID":12256,"AttributeSetID":null,"Name":"Sonstige"},{"IsLeaf":1,"IsVirtual":"","ExternalCategoryId":139069,"IsExpired":"","ParentCategoryID":12240,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":3,"EbayCategoryID":12247,"AttributeSetID":null,"Name":"Versandtaschen & -kartons"},{"IsLeaf":"","IsVirtual":"","ExternalCategoryId":111999,"IsExpired":"","ParentCategoryID":12240,"UseSiteReturnPolicyAttributeSetID":1,"UseSiteConditionAttributeSetID":1,"CategoryLevel":3,"EbayCategoryID":12248,"AttributeSetID":null,"Name":"Vinyl-Aufbewahrung"}],"Success":true}',
        response = JSON.parse(responseString),

        inputResponseString = '{"EbayCategoryID":12247,"ParentCategoryID":12240,"Success":true}',
        inputResponse = JSON.parse(inputResponseString),

        checkCatPath = function(dialog, catPathId, catName) {
            // check category path
            var testElem = dialog.find('[data-ebay=' + catPathId + ']');

            QUnit.equal(
                testElem.length,
                1,
                'category path contains an element with id "' + catPathId + '"'
            );
            QUnit.ok(
                (new RegExp(catName)).test(testElem.text()),
                'category path contains an element with name "' + catName + '"'
            );
        },

        checkCatFolder = function (dialog, catBrowserFolderId, folderName) {
            var testElem = dialog.find('[data-ebay=' + catBrowserFolderId + ']');

            QUnit.equal(
                testElem.length,
                1,
                'category browser contains a folder element with id "' + catBrowserFolderId + '"'
            );
            QUnit.ok(
                (new RegExp(folderName)).test(testElem.text()),
                'category browser contains a folder element with name "' + folderName + '"'
            );
        },

        checkCatLeaf = function (dialog, catBrowserLeafId, leafName) {
            var testElem = dialog.find('[data-ebay=' + catBrowserLeafId + ']');

            QUnit.equal(
                testElem.length,
                1,
                'category browser contains a leaf element with id "' + catBrowserLeafId + '"'
            );
            QUnit.ok(
                (new RegExp(leafName)).test(testElem.text()),
                'category browser contains a leaf element with name "' + leafName + '"'
            );
        },

        checkListLength = function(dialog, length) {
            var testElem = dialog.find('.ep-ebay-categorylist li');

            QUnit.equal(
                testElem.length,
                length,
                'category browser contains "' + length + '" selectable categories and leafs'
            );
        };

    QUnit.asyncTest("widget test presence of methods", function () {

        $.each([
            '_create',
            'setActiveCategorySelector',
            '_handleCategoryButtonClick',
            '_initDialog',
            '_resizeDialog',
            '_inputHandler',
            '_handleListClick',
            '_setInitialCategoryPath',
            '_setCategoryPath',
            '_deleteCategory',
            '_loadCategory',
            '_renderParentCategoryList',
            '_renderBreadcrump',
            '_renderErrors',
            '_hideErrors',
            '_handleError',
            '_initTooltip',
            '_handleTooltip',
            '_isJQueryElement',
            'destroy'
        ], function (i, fn) {
            QUnit.equal(
                $.isFunction($.ui.ebayCategorycontroller.prototype[fn]),
                true,
                '$.isFunction(' + fn + '):'
            );
        });

        QUnit.start();
    });

    QUnit.asyncTest("test UI", function () {
        var $categoryControllerElem = $('#ep-ebay-categorycontroller'),
            $btn1 = $('#cat1Button'),
            $btn2 = $('#cat2Button'),
            catPathId = 25,
            catBrowserFolderId = 12222,
            catBrowserLeafId = 12052,

            catBrowserRequestFolderId = 12240,
            catBrowserRequestLeafId = 12246,

            testId,
            widget,
            $categorybrowserdialog,
            storedCatId,
            testElem,
            removeButton,
            input,
            externalCategoryId;

        $categoryControllerElem.ebayCategorycontroller({
            controller: controller,
            changeAction: 'JSONUnityGetSubCategoryListById',
            objectId: 20928,
            busyTarget: $('#qunit-fixture'),
            ebayCatVersion: 116,

            // controller object for ebay categories
            categorySelectors: [{
                // first category
                storedId: 12052,
                currentId: 25,
                pathOutput: $('#EbayCategoryPath'),
                catOutput: $('#' + 'EbayCategoryId')
            }, {
                // second category
                storedId: 0,
                currentId: 0,
                pathOutput: $('#SecondCategoryPath'),
                catOutput: $('#' + 'SecondCategoryId')
            }],

            // options for category browser dialog
            dialogCtrl: {
                btnCat1: $btn1,
                btnCat2: $btn2,
                form: $('#qunit-fixture'),
                dialogClass: 'ep-ebay-categorybrowserdialog',
                dialogRoot: $('#ebayCategoryBrowser')
            }
        });

        /* START - fake ajax request */
        ep.ajax = function (o) {
            var result = $.Deferred(),
                resolveSend;

            if (o.data && o.data.ChangeAction) {
                if (o.data.ChangeAction === "JSONUnityGetSubCategoryListById") {
                    result.resolve(response);
                } else if (o.data.ChangeAction === "JSONUnityGetInternalCategoryId") {
                    result.resolve(inputResponse);
                }
            } else {
                result.reject();
            }

            return result;
        };
        /* END - fake ajax request */

        $btn1.trigger('click');
        window.setTimeout(function () {
            // it is necessary to reference the element again (otherwise the widget is *undefined*)
            widget = $('#ep-ebay-categorycontroller').data('uiEbayCategorycontroller');

            QUnit.equal(
                (widget !== undefined),
                true,
                'widget is resolved'
            );

            QUnit.equal(
                widget.dialog.uiDialog('isOpen'),
                true,
                'dialog is open'
            );

            // get dialog
            $categorybrowserdialog = $('.ep-ebay-categorybrowserdialog');

            // check category path
            checkCatPath($categorybrowserdialog, catPathId, controller[catPathId].Name);

            // check *folder* category
            checkCatFolder($categorybrowserdialog, catBrowserFolderId, controller[catBrowserFolderId].Name);

            // check *leaf* category
            checkCatLeaf($categorybrowserdialog, catBrowserLeafId, controller[catBrowserLeafId].Name);

            // check number of available category
            checkListLength($categorybrowserdialog, Object.keys(controller).length - 1);

            // check ID input
            input = $categorybrowserdialog.find('#categoryInput');
            QUnit.equal(
                input.length,
                1,
                'category browser contains an input element for category id "' + catBrowserLeafId + '"'
            );

            // check external id in input
            storedCatId = widget.options.categorySelectors[0].storedId;
            QUnit.equal(
                parseInt(input.val()),
                controller[storedCatId].ExternalCategoryId,
                'value of input element for a category equals the external id for the first category (' + controller[storedCatId].ExternalCategoryId + ')'
            );

            QUnit.ok(true, "=================== [AJAX tests (select a folder)] ===================");

            // // trigger click to folder item => initiates an ajax request
            $('#' + catBrowserRequestFolderId).trigger('click');

            window.setTimeout(function() {
                // it is necessary to reference the element again (otherwise the widget is *undefined*)
                widget = $('#ep-ebay-categorycontroller').data('uiEbayCategorycontroller');

                // check category path
                checkCatPath($categorybrowserdialog, catBrowserRequestFolderId, response.CurrentCategory.Name);

                // check *folder* category
                checkCatFolder($categorybrowserdialog, 12241, response.CategoryList[0].Name);

                // check *leaf* category
                checkCatLeaf($categorybrowserdialog, 12246, response.CategoryList[1].Name);

                // check number of available category
                checkListLength($categorybrowserdialog, response.CategoryList.length);

                externalCategoryId = controller[storedCatId].ExternalCategoryId;
                // check external id in input
                QUnit.equal(
                    parseInt(input.val()),
                    externalCategoryId,
                    'value of input element for a category still equals the external id ' + controller[storedCatId].ExternalCategoryId + ' (no leaf was selected)'
                );

                QUnit.ok(true, "=================== [select a leaf] ===================");

                // trigger click to leaf item => selects the category and write corresponding id to input
                $('#' + response.CategoryList[1].EbayCategoryID).trigger('click');

                window.setTimeout(function() {
                    // it is necessary to reference the element again (otherwise the widget is *undefined*)
                    widget = $('#ep-ebay-categorycontroller').data('uiEbayCategorycontroller');

                    testId = response.CategoryList[1].ExternalCategoryId;

                    // check external id in input
                    QUnit.equal(
                        parseInt(input.val()),
                        testId,
                        'value of input element for a category (inside the dialog) equals the external id ' + testId + ' (leaf was selected)'
                    );

                    // check external id in input
                    QUnit.equal(
                        parseInt(widget.options.categorySelectors[widget.activeSelectorIndex].catOutput.val()),
                        testId,
                        'value of input element for a category (in the document) equals the external id ' + testId + ' (leaf was selected)'
                    );

                    // check category path
                    testElem = widget.options.categorySelectors[widget.activeSelectorIndex].pathOutput.find('p:last');

                    QUnit.ok(
                        (new RegExp(response.CategoryList[1].Name)).test(testElem.text()),
                        'category path inside the main document contains a leaf element with name "' + response.CategoryList[1].Name + '"'
                    );

                    QUnit.ok(true, "=================== [close dialog, test remove button] ===================");

                    // close dialog
                    widget.dialog.closest('.ui-dialog').find('.ui-dialog-buttonpane button').trigger('click');
                    QUnit.equal(
                        widget.dialog.uiDialog('isOpen'),
                        false,
                        'dialog is closed'
                    );

                    // get reference to remove button
                    removeButton = widget.options.categorySelectors[widget.activeSelectorIndex].pathOutput.find('span.fa-trash');

                    // check existence of delete button
                    QUnit.equal(
                        removeButton.length,
                        1,
                        'button to remove cateogory exists'
                    );

                    // remove category and open dialog again
                    removeButton.trigger('click');
                    $btn1.trigger('click');

                    // check input in main document
                    QUnit.equal(
                        widget.options.categorySelectors[widget.activeSelectorIndex].catOutput.val().length,
                        0,
                        'input element for a category in main document is empty'
                    );

                    // check input in dialog
                    input = $categorybrowserdialog.find('#categoryInput');
                    QUnit.equal(
                        input.val().length,
                        0,
                        'input element for a category in dialog is empty'
                    );

                    externalCategoryId = 139069; // corresponding epages Ebay category: 12247
                    input.val(externalCategoryId);
                    input.trigger('input');

                    window.setTimeout(function() {
                        // it is necessary to reference the element again (otherwise the widget is *undefined*)
                        widget = $('#ep-ebay-categorycontroller').data('uiEbayCategorycontroller');

                        // is correct radio button checked?
                        QUnit.ok($('#' + widget.activeCategorySelector.currentSelectedLeaf).find('input[type=radio]').prop('checked'), "the correct leaf was selected");

                        QUnit.start();
                    }, 800);
                }, 200);
            }, 200);
        }, 100);
    });
});